#!/bin/sh
#
#*******************************************************************
# Copyright(C) Kyushu Hitachi Systems,Ltd.2014.All Rights Reserved.
#*******************************************************************
parseParameters()
{
    cgiroot='.'
    convertFilePath='.'
    para='NULL'
    
    for getPara in $getParameters
    do
        case $para in
            'NULL')
                case $getPara in
                    '-d' )
                        para='d'
                        ;;
                    '-f' )
                        para='f'
                        ;;
                esac
                ;;
            'd')
                cgiroot=$getPara
                para='NULL'
                ;;
            'f')
                convertFilePath=$getPara
                para='NULL'
                ;;
        esac
    done
}
#ディレクトリ存在チェック
checkDirectoryExists()
{
    #初期値
    directoryExists=0
    #パラメータより取得
    dirPara=$1
    #値渡し
    directoryToBeChecked=$dirPara
    #ディレクトリが存在する場合は1を返却
    if [ -d $directoryToBeChecked ]; then
        directoryExists=1
    fi
}
#data付加
DirectoryPathHasATrailing()
{
    currentDirectory=`pwd`
    pathToPossiblySlashlessDirectory=$1
    cd $pathToPossiblySlashlessDirectory
    pathToDirectoryWithTrailingData=`pwd`'/data'
    checkDirectoryExists $pathToDirectoryWithTrailingData
    cd $currentDirectory
    if [ $directoryExists = 1 ]; then
        dirExists=1
    else
        dirExists=0
        #logディレクトリを作成する
        if [ ! -d ./log ]; then
            mkdir -p ./log
        fi
        execTime=`date +%H:%M:%S`
        echo "エラー：desknet'sNEOのcgi-rootを指定してください。"
        echo "$execTime"" エラー：desknet'sNEOのcgi-rootを指定してください。" >> $targetLogFile
    fi
}
#パラメータチェック
checkParameters()
{
    verifyParameters=0
    #カレントディレクトリ？
    if [ $cgiroot = '.' ]; then
        dirExists=0
        #logディレクトリを作成する
        if [ ! -d ./log ]; then
            mkdir -p ./log
        fi
        execTime=`date +%H:%M:%S`
        echo 'エラー：必須パラメータが指定されていません。'
        echo "$execTime"" エラー：必須パラメータが指定されていません。" >> $targetLogFile
    else
        #ディレクトリ存在チェック
        checkDirectoryExists $cgiroot
        if [ $directoryExists = 1 ]; then
            dirExists=1
            #末尾に/dataを付与する
            DirectoryPathHasATrailing $cgiroot
            #desknet'sNEOのcgi-rootに[data]付加
            cgiroot=$pathToDirectoryWithTrailingData
        else
            dirExists=0
            #logディレクトリを作成する
            if [ ! -d ./log ]; then
                mkdir -p ./log
            fi
            execTime=`date +%H:%M:%S`
            echo "エラー：""$cgiroot""が存在しません。"
            echo "$execTime"" エラー：""$cgiroot""が存在しません。" >> $targetLogFile
        fi
    fi
    if [ $dirExists = 1 ]; then
        #カレントディレクトリ？※コンバート結果ファイルフルパス
        if [ $convertFilePath = '.' ]; then
            destinationDirectoryExists=0
            #logディレクトリを作成する
            if [ ! -d ./log ]; then
                mkdir -p ./log
            fi
            execTime=`date +%H:%M:%S`
            echo 'エラー：必須パラメータが指定されていません。'
            echo "$execTime"" エラー：必須パラメータが指定されていません。" >> $targetLogFile
        else
            #ファイル取得
            targetFile=`echo ${convertFilePath} | awk -F'/' '{print $NF}'`
            getdir=`echo $convertFilePath | sed -e "s/$targetFile//"`
            #ディレクトリ存在チェック
            checkDirectoryExists $getdir
            if [ $directoryExists = 1 ]; then
                destinationDirectoryExists=1
            else
                #logディレクトリを作成する
                if [ ! -d ./log ]; then
                    mkdir -p ./log
                fi
                execTime=`date +%H:%M:%S`
                echo "エラー：""$getdir""が存在しません。"
                echo "$execTime"" エラー：""$getdir""が存在しません。" >> $targetLogFile
            fi
        fi
    fi
    [ $dirExists = 1 ] &&
    [ "$destinationDirectoryExists" = 1 ] &&
    verifyParameters=1
}
#パラメータ作成処理＆exeコール
makePara()
{
    #appファイルを取得
    while read line
    do
        #イコールの数を取得
        getequal=`echo ${line} | sed -e 's@[^=]@@g' `
        #数値として判定する
        EQ_COUNT=`expr ${#getequal}`
        #イコールの数が1以上の場合処理
        if [ `expr $EQ_COUNT` -eq 1 ]; then
            #取得したレコードをイコールで分割
            eq=`echo ${line} | cut -d '=' -f 1`
            #dbs？
            if [ "$eq" = "dbs" ]; then
                #dbs取得
                dbs=`echo ${line} | cut -d '=' -f 2`
            fi
            #dbuser？
            if [ "$eq" = "dbuser" ]; then
                #dbuser取得
                dbuser=`echo ${line} | cut -d '=' -f 2`
            fi
            #dbname？
            if [ "$eq" = "dbname" ]; then
                #dbname取得
                dbname=`echo ${line} | cut -d '=' -f 2`
            fi
            #dbpwd？
            if [ "$eq" = "dbpwd" ]; then
                #dbpwd取得
                dbpwd=`echo ${line} | cut -d '=' -f 2`
            fi
            #dbport？
            if [ "$eq" = "dbport" ]; then
                #dbport取得
                dbport=`echo ${line} | cut -d '=' -f 2`
            fi
        else
            #ホストとポートが同じ行に配置されている場合
            if [ `expr $EQ_COUNT` -eq 2 ]; then
                CNT=0
                while :
                do
                    CNT=`expr $CNT + 1`
                    eq=`echo ${line} | cut -d '=' -f ${CNT}`
                    #ホスト
                    if [ "$eq" = "dbs" ]; then
                        VAL=`expr $CNT + 1`
                        host=`echo ${line} | cut -d '=' -f ${VAL}`
                        dbs=`echo ${host} | cut -d ' ' -f ${CNT}`
                        port=`echo ${host} | cut -d ' ' -f ${VAL}`
                        #ポート
                        if [ "$port" = "port" ]; then
                            VAL=`expr $VAL + 1`
                            dbport=`echo ${line} | cut -d '=' -f ${VAL}`
                            break
                        fi
                    fi
                done
            fi
        fi
    done < "$file"
}
#appファイル検索
SearchProc()
{
    CONFIRM=0
    for file in `find ${cgiroot} -type f`
    do
        if [ -e "$file" ]; then
            #appファイル取得
            name=`(echo ${file##*/})`
            #appファイル
            if [ "$name" = "app" ]; then
                #app格納ディレクトリ取得
                dir=`dirname $file`
                #パラメータ作成処理実行
                makePara
                CONFIRM=1
            fi
        fi
    done
}
#メイン処理
mainProc() {
    #sh実行ディレクトリ取得
    DIR=`dirname ${0}`
    #ログファイル名を作成
    targetLogFile=$DIR/log/convidout.log
    #パラメータ取得処理
    parseParameters
    #パラメータチェック処理
    checkParameters
    #チェック処理が正常だった場合処理開始
    if [ $verifyParameters = 1 ]; then
        #パラメータ(DB情報)取得
        SearchProc
        #必須パラメータでデフォルト設定されない
        #パラメータを加工
        #dbname
        if [ "$dbname" = '' ]; then
            dbname='dneodb'
        fi
        #dbport
        if [ "$dbport" = '' ]; then
            dbport=5432
        fi
        #appファイルは存在？
        if [ "$CONFIRM" = 0 ]; then
            #logディレクトリを作成する
            if [ ! -d ./log ]; then
                mkdir -p ./log
            fi
            execTime=`date +%H:%M:%S`
            echo "エラー：appファイルが存在しません。"
            echo "$execTime"" エラー：appファイルが存在しません。" >> $targetLogFile
        else
            #logディレクトリを作成する
            if [ ! -d ./log ]; then
                mkdir -p ./log
            fi
            #スケジュールID変換ファイル出力バッチKICK
            ./SchidConvFileOut "$dbs" "$dbname" "$dbuser" "$dbpwd" "$dbport" "$convertFilePath"
        fi
    fi
}
#パラメータ
getParameters=$@
mainProc
